#include <iostream>
using namespace std;

//numero delle regine da considerare
const int m = 8;
int k = 0;

void stampa(int* Q) {
	for (int i=0;i<m;i++)
		cout << Q[i] << '\t';
	cout << endl;
}

//metodo di verifica
bool verifica(int* Q) {
	//poniamo inizialmente il valore a true
	bool flag = true;
	for (int i=0; i<=k; i++) {
		for (int j=0; j<=k; j++) {
			//se gli indici sono diversi
			if (i!=j) {
				//colonne o righe
				if (Q[i]==Q[j])
					flag = false;
				//controllo diagonali
				if ( (i-Q[i]==j-Q[j]) || (i+Q[i]==j+Q[j]) )
					flag = false;
			}
		}
	}
	return flag;
}

void genera(int* Q) {
	bool nextPos;
	bool successo;
	
	Q[k] = 0;
	successo = false;	
	do 
    {
		if (!verifica(Q)) 
        {
		    //system("pause");
            cout << "verifica fallita \n";
            stampa(Q);              
			do 
            {
				if (Q[k]<m-1) 
                {
					nextPos = true;
					cout << "**********************************************" << "\n";
                    cout << "provo ad assegnare la regina "<< k+1 << "\n";
				    cout << "in riga "<< k << " e colonna "<<Q[k]+1 << "\n";
                    Q[k] =Q[k]+1;
				}
				else 
                {
					nextPos = false;
					cout << "**********************************************" << "\n";
					cout << "non ho piu' regine da assegnare  pertanto torno indietro e rivaluto" << "\n";
					k = k-1;
				}
			}while (!nextPos && k>0);
		}
		else 
		{
             cout << "verifica ok regine assegnate "<< k+1 << "\n";
             cout << "regina "<< k+1 << " assegnata in riga "<< k << " e colonna "<<Q[k]<< "\n";
             stampa(Q); 
             if (k==(m-1)) 
             {
                //verifica ok ed ho assegnato tutte le regine
			    successo = true;
		     }
		     else 
             {
                  //non ho assegnato tutte e 8 le regine
			      k = k+1;
			      Q[k] = 0;
			      cout << "**********************************************" << "\n";
                  cout << "provo ad assegnare la regina "<< k+1 << "\n";
				  cout << "in riga "<< k << " e colonna "<<Q[k] << "\n";
             }
         }
	} while (!successo && k>0);
	
}

int main() {
	//array contenente le 8 regine
	int* Q = new int[m];
	for (int i=0; i<m; i++)
		//inizializzo l'array con tutti 0
		Q[i] = 0;
	
	genera(Q);
	//system("pause");
}
