using namespace std;


typedef struct Grafo {
	int n_nodi;
	int** nodi;
} * LGrafo;

const int MAX_INT = 32767;

void InitGrafo(Grafo& g, int n_nodi);
void Connect(Grafo& g, int x, int y);
void Connect(Grafo& g, int x, int y, int peso);
void VisitaAmpiezza(Grafo& g, int s);
void VisitaProfondita(Grafo& g, int s);
void VisitaProfonditaRicor(Grafo& g, int s, int* v);
void Dijkstra(Grafo& g, int s);
